package com.muyu.rule.server;


import com.muyu.rule.server.complie.SourceCodeComplier;
import com.muyu.rule.server.execution.EngineExecution;
import com.muyu.rule.server.load.JavaBinaryClassLoader;
import com.muyu.rule.server.pool.container.EngineContainer;

import java.util.HashMap;
import java.util.Map;

/**
 * @Author：张承志
 * @Package：com.muyu.rule.server
 * @Project：cloud-etl-rule
 * @name：EngineTest
 * @Date：2024/8/22 18:55
 */
public class EngineTest {

    public static void main(String[] args) throws InstantiationException, IllegalAccessException, NoSuchMethodException {

        EngineConfig engineConfig = new EngineConfig();

        //扫描原码进行编译+-+-
        SourceCodeComplier.javaCompilerPath(engineConfig.getLocation());
//对class文件进行自定义类加载规则引擎
  Map<String ,Class<?>> stringClassMap  = JavaBinaryClassLoader.loadClassesByLocation(engineConfig.getPack(),engineConfig.getLocation());
        System.out.println("====>"+stringClassMap);
        stringClassMap.forEach((key,value)->{
            EngineContainer.loadEngineInstance(key,value);
        });

        Map<String, Object> params = new HashMap<>();
params.put("idcard","142021200212215977");
       Object engineObject = EngineExecution.engineExe("Engine_2024_8_23_2347", params);

        System.out.println("====>"+engineObject);



    }


}
