package com.muyu.rule.server;

import com.muyu.rule.common.domain.DataValue;
import com.muyu.rule.server.basic.BasicEngine;
import com.muyu.rule.server.basic.engine.ENGINE_VALUE_VFD1000_V1;

import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

/**
 * @Author：张承志
 * @Package：com.muyu.rule.server
 * @Project：cloud-etl-rule
 * @name：Main
 * @Date：2024/8/29 15:57
 */
public class Main {

 static    Map<String , BasicEngine<DataValue>> engineMap = new ConcurrentHashMap<>();


    static {
        try {
            Class<?> aClass = Class.forName("com.muyu.rule.server.basic.engine.ENGINE_VALUE_VFD1000_V1");

            try {
                engineMap.put("ENGINE_VALUE_VFD1000_V1", (BasicEngine<DataValue>) aClass.newInstance());
            } catch (InstantiationException e) {
                throw new RuntimeException(e);
            } catch (IllegalAccessException e) {
                throw new RuntimeException(e);
            }
        } catch (ClassNotFoundException e) {
            throw new RuntimeException(e);
        }

    }


    public static void main(String[] args) {
        DataValue dataValue = DataValue.builder()
                .type("String")
                .label("姓名")
                .key("name")
                .value(null)
                .build();

        BasicEngine<DataValue> engineValue = engineMap.get("ENGINE_VALUE_VFD1000_V1");

        engineValue.set(dataValue);

        engineValue.execution();


    }












}


