package com.muyu.rule.server.service.impl;


import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.muyu.common.core.enums.SystemYesNo;
import com.muyu.rule.common.domain.RuleEngine;
import com.muyu.rule.common.domain.RuleEngineVersion;
import com.muyu.rule.common.utils.OssUtil;
import com.muyu.rule.server.mapper.RuleEngineVersionMapper;
import com.muyu.rule.server.scan.JavaCodeScan;
import com.muyu.rule.server.service.RuleEngineVersionService;
import org.springframework.stereotype.Service;

import java.io.ByteArrayInputStream;
import java.io.File;
import java.nio.charset.StandardCharsets;
import java.util.Base64;
import java.util.List;

import static com.muyu.rule.server.constant.SuffixClass.Suffix_JAVA;

/**
 * @Author：张承志
 * @Package：com.muyu.rule.server.service.impl
 * @Project：cloud-etl-rule
 * @name：RuleEngineServiceImpl
 * @Date：2024/8/25 14:17
 */
@Service
public class RuleEngineServiceImpl extends ServiceImpl<RuleEngineVersionMapper,RuleEngineVersion> implements RuleEngineVersionService {


    @Override
    public List<RuleEngineVersion> selectRuleEngineVersion(Long id) {

        LambdaQueryWrapper<RuleEngineVersion> queryWrapper = new LambdaQueryWrapper<>();

        queryWrapper.eq(
     RuleEngineVersion::getRuleId,id);

        List<RuleEngineVersion> versionList = this.list(queryWrapper);


        return versionList;
    }

    @Override
    public void activate(Long id) {
        this.updateOpen(id, SystemYesNo.YES.getCode());
    }

    @Override
    public void disable(Long id) {
        this.updateOpen(id, SystemYesNo.NO.getCode());
    }

    @Override
    public String dataGenerate(String dataSource) {




        return null;
    }

    /**
     *
     * @param versionClazz 具体代码
     * @param className 类的名
     */
    @Override
    public void Upload(String versionClazz,String className) {

// 使用ByteArrayInputStream将字符串内容转换为输入流
        ByteArrayInputStream inputStream = new ByteArrayInputStream(versionClazz.getBytes());


        OssUtil.uploadFileInputStreamForBucket("mall-bw",className,inputStream);






        //    OssUtil.uploadFileInputStreamForBucket(,"E:\\practical_training\\cloud-etl-rule\\cloud-rule-server\\src\\main\\java\\com\\muyu\\rule\\server\\engine\\");



    }


    /**
     * 修改激活
     * @param id
     * @param open
     */
    public void updateOpen(Long id, String open){


        UpdateWrapper<RuleEngineVersion> updateWrapper = new UpdateWrapper<>();

        updateWrapper.eq("id",id).set("open",open);

        this.update(updateWrapper);

    }



}
